﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SimpleBlog.Models;
using System.Data.Entity;
using SimpleBlogDAL;
using System.Net.Mail;
using System.Net;

namespace SimpleBlog.Controllers
{
    public class AcountController : Controller
    {
        DatabaseEntities entities = new DatabaseEntities();

        public ActionResult Login()
        {
            entities = new DatabaseEntities();
            return View();
        }
        public ActionResult LoginProcess(LoginVM loginUser)
        {
            var existingUsers =
                (from usr in entities.Users
                where usr.username == loginUser.Username &&
                usr.password == loginUser.Password
                select usr).SingleOrDefault();

            if (existingUsers != null)
            {
                Session["Logged"] = existingUsers;

                User loggedUser = (User)Session["Logged"];

                return RedirectToAction("Index", "Blog");
            }
            else
            {
                return RedirectToAction("Login", "Acount");
            }
        }

        public ActionResult Register()
        {
            entities = new DatabaseEntities();

            return View();
        }
        public ActionResult RegisterProcess(RegisterVM user)
        {
            entities = new DatabaseEntities();
            User exampleUser = new User();

            exampleUser.username = user.Username;
            exampleUser.password = user.Password;
            exampleUser.email = user.Email;
            exampleUser.ages = user.Ages;
            exampleUser.country = user.Country;
            exampleUser.is_admin = false;

            var sameUsers = from usr in entities.Users
                            where usr.username == exampleUser.username || usr.email == exampleUser.email
                            select usr;

            if (sameUsers.Count() > 0)
            {
                return RedirectToAction("Register", "Acount");
            }
            else
            {
                entities.Users.AddObject(exampleUser);
                entities.SaveChanges();
                return RedirectToAction("Login", "Acount");
            }
        }

        public ActionResult Logout()
        {
            Session["Logged"] = null;
            return RedirectToAction("Login", "Acount");
        }
        public ActionResult ViewProfile()
        {
            User user = (User)Session["Logged"];
            return View(user);
        }

        public ActionResult LostPassword()
        {
            LostPassVM lost = new LostPassVM();

            return View(lost);
        }
        [HttpPost]
        public ActionResult LostPassword(LostPassVM lost)
        {
            var existingEmail = entities.Users.Where(x => x.email == lost.Email).FirstOrDefault();

            if (existingEmail == null)
            {
                return View("NoSuchEmail");
            }
            else
            {
                User user = (User)existingEmail;

                SmtpClient client = new SmtpClient("smtp.gmail.com", 587);
                client.EnableSsl = true;

                NetworkCredential credential = new NetworkCredential("mr.skromnost@gmail.com", "9101124480");
                client.Credentials = credential;

                try
                {
                    SendMail(existingEmail.email,
                    "mr.skromnost@gmail.com",
                    "Lost Password for Simple Blog.",
                    user, client, credential);
                }
                catch (Exception ex)
                {
                    throw ex;
                }

            }

            return View("RecoveredPassword");
        }

        public void SendMail(String Receiver, String Sender, String Subject, User account,
            SmtpClient client, NetworkCredential credential)
        {
            MailMessage mail = new MailMessage();
            mail.To.Add(Receiver);
            mail.From = new MailAddress(Sender);
            mail.Subject = Subject;
            mail.Body =   "Hello dear User!\n" + 
                          "You were lost your password for site\n"+
                          "www.simpleblog.com and now we send to you\n"+
                          "your acount info to recover your profile.\n"+

                          "\nEmail address: " + account.email +
                          "\nUsername: " + account.username +
                          "\nPassword: " + account.password +
                          "\nCountry: " + account.country +
                          "\nAges: " + account.ages;

            client.Send(mail);
        }
    }
}
