﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SimpleBlogDAL;

namespace SimpleBlog.Controllers
{
    public class CategoryController : Controller
    {
        private DatabaseEntities db = new DatabaseEntities();

        public ViewResult Index()
        {
            var categories = db.Categories.Include("Blog");
            return View(categories.ToList());
        }

        public ViewResult Details(int id)
        {
            Category category = db.Categories.Single(c => c.category_id == id);
            return View(category);
        }

        public ActionResult Create()
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            ViewBag.blog_id = blog.blog_id;
            return View();
        }
        [HttpPost]
        public ActionResult Create(Category category)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            category.blog_id = blog.blog_id;

            if (ModelState.IsValid)
            {
                db.Categories.AddObject(category);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.blog_id = blog.blog_id;
            return View(category);
        }

        public ActionResult Edit(int id)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            Category category = db.Categories.Single(c => c.category_id == id);
            ViewBag.blog_id = blog.blog_id;
            return View(category);
        }
        [HttpPost]
        public ActionResult Edit(Category category)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            category.blog_id = blog.blog_id;
            if (ModelState.IsValid)
            {
                db.Categories.Attach(category);
                db.ObjectStateManager.ChangeObjectState(category, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.blog_id = blog.blog_id;
            return View(category);
        }

        public ActionResult Delete(int id)
        {
            Category category = db.Categories.Single(c => c.category_id == id);
            return View(category);
        }
        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            Category category = db.Categories.Single(c => c.category_id == id);
            db.Categories.DeleteObject(category);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}