﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SimpleBlogDAL;

namespace SimpleBlog.Controllers
{
    public class MenuController : Controller
    {
        private DatabaseEntities db = new DatabaseEntities();

        public ViewResult Index()
        {
            var menus = db.Menus.Include("Blog");
            return View(menus.ToList());
        }

        public ViewResult Details(int id)
        {
            Menu menu = db.Menus.Single(m => m.menu_id == id);
            return View(menu);
        }

        public ActionResult Create()
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            ViewBag.blog_id = blog.blog_id;
            return View();
        }
        [HttpPost]
        public ActionResult Create(Menu menu)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            menu.blog_id = blog.blog_id;

            if (ModelState.IsValid)
            {
                db.Menus.AddObject(menu);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.blog_id = blog.blog_id;
            return View(menu);
        }

        public ActionResult Edit(int id)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            Menu menu = db.Menus.Single(m => m.menu_id == id);
            ViewBag.blog_id = blog.blog_id;
            return View(menu);
        }
        [HttpPost]
        public ActionResult Edit(Menu menu)
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            menu.blog_id = blog.blog_id;

            if (ModelState.IsValid)
            {
                db.Menus.Attach(menu);
                db.ObjectStateManager.ChangeObjectState(menu, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.blog_id = blog.blog_id;
            return View(menu);
        }

        public ActionResult Delete(int id)
        {
            Menu menu = db.Menus.Single(m => m.menu_id == id);
            return View(menu);
        }
        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            Menu menu = db.Menus.Single(m => m.menu_id == id);
            db.Menus.DeleteObject(menu);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}