﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SimpleBlogDAL;

namespace SimpleBlog.Controllers
{
    public class PageController : Controller
    {
        private DatabaseEntities db = new DatabaseEntities();
        public ViewResult Index()
        {
            var pages = db.Pages.Include("Menu");
            return View(pages.ToList());
        }

        public ViewResult Details(int id)
        {
            Page page = db.Pages.Single(p => p.page_id == id);
            return View(page);
        }

        public ActionResult Create()
        {
            Blog blog = (Blog)Session["CurrentBlog"];
            ViewBag.menu_id = new SelectList(db.Menus.Where(x=>x.blog_id == blog.blog_id), "menu_id", "name");
            return View();
        }
        [HttpPost]
        public ActionResult Create(Page page)
        {
            if (ModelState.IsValid)
            {
                db.Pages.AddObject(page);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.menu_id = new SelectList(db.Menus, "menu_id", "name", page.menu_id);
            return View(page);
        }

        public ActionResult Edit(int id)
        {
            Page page = db.Pages.Single(p => p.page_id == id);
            Blog blog = (Blog)Session["CurrentBlog"];
            ViewBag.menu_id = new SelectList(db.Menus.Where(x=>x.blog_id == blog.blog_id), "menu_id", "name", page.menu_id);
            return View(page);
        }
        [HttpPost]
        public ActionResult Edit(Page page)
        {
            if (ModelState.IsValid)
            {
                db.Pages.Attach(page);
                db.ObjectStateManager.ChangeObjectState(page, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.menu_id = new SelectList(db.Menus, "menu_id", "name", page.menu_id);
            return View(page);
        }

        public ActionResult Delete(int id)
        {
            Page page = db.Pages.Single(p => p.page_id == id);
            return View(page);
        }
        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            Page page = db.Pages.Single(p => p.page_id == id);
            db.Pages.DeleteObject(page);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}