﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SimpleBlogDAL;

namespace SimpleBlog.Controllers
{
    public class ThemeController : Controller
    {
        private DatabaseEntities db = new DatabaseEntities();

        public ViewResult Index()
        {
            return View(db.Themes.ToList());
        }

        public ViewResult Details(int id)
        {
            Theme theme = db.Themes.Single(t => t.theme_id == id);
            return View(theme);
        }

        public ActionResult Create()
        {
            return View();
        }
        [HttpPost]
        public ActionResult Create(Theme theme)
        {
            if (ModelState.IsValid)
            {
                db.Themes.AddObject(theme);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            return View(theme);
        }

        public ActionResult Edit(int id)
        {
            Theme theme = db.Themes.Single(t => t.theme_id == id);
            return View(theme);
        }
        [HttpPost]
        public ActionResult Edit(Theme theme)
        {
            if (ModelState.IsValid)
            {
                db.Themes.Attach(theme);
                db.ObjectStateManager.ChangeObjectState(theme, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(theme);
        }

        public ActionResult Delete(int id)
        {
            Theme theme = db.Themes.Single(t => t.theme_id == id);
            return View(theme);
        }
        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            Theme theme = db.Themes.Single(t => t.theme_id == id);
            db.Themes.DeleteObject(theme);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}